Name: qmail
Version: 1.03
Release: 41%{?dist}
Group: Utilities/System
URL: http://www.qmail.org/
License: Check with djb@koobera.math.uic.edu
Source0: ftp://koobera.math.uic.edu/pub/software/qmail-1.03.tar.gz
Source1: ftp://koobera.math.uic.edu/pub/software/dot-forward-0.71.tar.gz
Source2: ftp://koobera.math.uic.edu/pub/software/fastforward-0.51.tar.gz
Source3: qmail-send-run.sh
Source4: qmail-send-log.sh
Source5: qmailctl-script-dt70
Source6: qmailrc
Source7: qmail-linux.sh
Source8: qmail-linux.csh
Source9: qmail-aliases
Source10: qmail-default
Source11: qmail-msglog
Source12: qmail-default-delivery
Source13: brand.c
Source14: auto_uids.c
Source15: qmail-smtpd-run.sh
Source16: qmail-smtpd-log.sh
Source17: mbox2maildir
Source19: qfilter-tmda
Source20: qmail-smtpd-auth-0.31.tar.gz
Source22: qmail-smtpd.init
Source24: libspf-1.0.0-p5.tar.bz2
Source25: find-osrel
Source26: qmail-qmtpd.init
Source27: qmail-qmtpd-run.sh
Source28: qmail-qmtpd-log.sh
Source29: qmail-dkim-0.2.pl
Source30: signconf.xml
Patch0: qmail-1.03.install.patch
Patch1: qmail-1.03.msglog.patch
Patch2: qmail-1.03.redhat.patch
Patch3: qmail-1.03.solaris.patch
Patch4: qmail-1.03.ids.patch
Patch6: qmail-1.03-mfcheck.3.patch
Patch7: qmailqueue.patch
Patch8: http://pyon.org/fujiwara/qmail-1.03-v6-20001010.diff.txt
Patch9: errno.patch
Patch10: auth.disable.cram.patch
Patch11: netqmail-1.04-tls-20040120.patch
Patch12: libspf.Makefile.static.patch
Patch13: libspf.patch
Patch14: libspf.configure.patch
Patch15: qmail-1.03-qmtpc.patch
Patch16: qmail-1.03.qmtpd-netstring.patch
Patch17: maildir.header.patch
Patch18: any-to-cname.patch
Patch19: big.dns.response.patch
Patch20: libspf.rhel6.patch
Patch21: libspf.post.configure.rhel6.patch
Summary: qmail Mail Transport Agent
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}
Provides: MTA smtpdaemon qmailmta qmail-server
Requires: checkpassword
%ifos linux
Requires: chkconfig
Requires: shadow-utils
%endif
Requires: daemontools >= 0.76
Requires: libdomainkeys >= 0.69
Requires: openssl
Requires: perl-Mail-DKIM >= 0.30.1
Requires: perl-XML-Simple
Requires: ucspi-tcp >= 0.88-6
Conflicts: sendmail qmail-client
ExclusiveOS: linux solaris2.9
Packager: david@summersoft.fay.ar.us
%description
qmail is a small, fast, secure replacement for the SENDMAIL package, which is
the program that actually receives, routes, and delivers electronic mail.

The dot-forward and fastforward packages have been added to this distribution
for (not 100%) SENDMAIL compatability.

SPAM fighting can be done with the rblsmtpd program from the ucspi-tcp package,
and also with the optional QMAILQUEUE functionality. This package
is now setup to allow optional use of the TMDA package (via the qmail-qfilter
package).

*** Note: The default deliver method is now Maildir. A good Maildir IMAP and
POP3 package is CourierIMAP.

*** Note: Be sure and read the documentation as there are some small but very
significant differences between SENDMAIL and QMAIL and the programs that
interact with them.

A sub-package, qmail-msglog, adds (configurable) message logging.  This has been
added as a sub-package since this necessarily slows things down a little bit and
the author feels it necessary to distinguish the added capability as an add-on
package.

An alternative package (smaller, easier to configure) is the qmail-client
package which will ONLY work on a LAN connected to the qmail mail server via
the QMQP protocol.

%package msglog
Requires: qmail
Summary: qmail Mail Transport Agent with Message Logging
Group: Utilities/System
%description msglog
qmail-msglog adds a (customizable) script that runs on each and every message
that goes through the mail system.  One usage example is to record Message IDs
in the log file.

%package client
Group: Utilities/System
Summary: qmail Mail Transport Agent
Provides: MTA smtpdaemon qmailmta
%description client
qmail-client is a small, fast, secure replacement for the SENDMAIL package,
which is the program that actually receives, routes, and delivers electronic
mail.

*** Note: This package is for a client only and REQUIRES the main qmail server
on a connected LAN.

*** Note: Be sure and read the documentation as there are some small but very
significant differences between SENDMAIL and QMAIL and the programs that
interact with them.

%changelog
* Mon Nov 28 2011 David Summers <david@summersoft.fay-ar.us> 1.03-41
- Rebuild for RHEL6.
- ADDED SMTPD_PORT variable to /etc/qmail/smtpd.config file.

* Sun Mar 20 2011 David Summers <david@summersoft.fay.ar.us> 1.03-40
- Added patch to change queries from ANY to CNAME.
  This is to undo a patch that DJB made to hack around BIND 4.9.4 problems.
  The result is that QMAIL doesn't query as much info and doesn't pollute
  the DNS cache with extraneous information.
  http://homepages.tesco.net/~J.deBoynePollard/Softwares/qmail/any-to-cname.patch

- Added patch to allow qmail to handle big DNS responses like the standards
  allow for.  This should prevent the problem sending to yahoo.com.

* Mon May 26 2008 David Summers <david@summersoft.fay.ar.us> 1.03-39
- Added new X-Maildir-File: header to qmail-local so we can tell which file
  the message has been delivered to (Useful for special TMDA processing).

* Mon Apr 14 2008 David Summers <david@summersoft.fay.ar.us> 1.03-38
- Added DKIM (RFC4871) (and DomainKeys) header injection.
  Requires perl-Mail-DKIM-0.30.1 or higher package.
  Requires perl-XML-Simple package.
  Requires libdomainkeys-0.69 or higher package.

* Sat Jun 30 2007 David Summers <david@summersoft.fay.ar.us> 1.03-37
- Changes for RHEl5.

  Changed "Copyright" tag to "License" so we can compile on RHEL5.
  "License" works at least back to Redhat 8.0 and maybe earlier (?).

  Fixed to compile for RHEL5. (Took out (re)definition of strerror.)

  Fixed OSREL lookup and aliases issue with RHEL5.

- Fixed line-ending problem with libspf-1.0.0-p5.

* Sat Jan 13 2007 David Summers <david@summersoft.fay.ar.us> 1.03-36
- Took out SMTPS service on port 465.
  No longer needed since we can do TLS/AUTH.

* Sat Aug 12 2006 David Summers <david@summersoft.fay.ar.us> 1.03-35
- Added QMTP service with qmail-remote patch for qmtpd and init scripts for
  /etc/init.d/qmail-qmtpd.
  Uses /etc/tcp.qmtp, updated with /etc/init.d/qmail-qmtpd rules.

* Sat Jul 29 2006 David Summers <david@summersoft.fay.ar.us> 1.03-34
- Change useradd/groupadd to create "system" accounts on Linux instead of
  normal user accounts.

* Mon Jun 12 2006 David Summers <david@summersoft.fay.ar.us> 1.03-33
- Fix file permission problem when building on RHEL3.

* Sat Jun 10 2006 David Summers <david@summersoft.fay.ar.us> 1.03-32
- Updated to libspf-1.0.0-p5.

* Sun Feb 19 2006 David Summers <david@summersoft.fay.ar.us> 1.03-31
- Changed init scripts to use "status" instead of "stat".

* Sun Dec 25 2005 David Summers <david@summersoft.fay.ar.us> 1.03-30
- Updated to work with RHEL4.

* Sat Apr 23 2005 David Summers <david@summersoft.fay.ar.us> 1.03-29
- Added documentation for AUTH (README.auth).
- Fixed /etc/qmail/Makefile certificate generation to generate a
  self-signed certificate by default for the AUTH command processing.
- Memory requirements keep going up.  Bump SMTPD memory to 500000.
  *** Note: Arbitrary errors seem to happen when it runs out of memory which
            make is very difficult to figure out.
- Take out /etc/qmail/control/plusdomain file.  I've NEVER EVER used it.

* Fri Apr 16 2004 David Summers <david@summersoft.fay.ar.us> 1.03-28
- Ported SPF to Solaris.  Untested.
- Now runs SPF test script.
- Fixed SPF to not activate if SMTP AUTH has been activated.

* Fri Apr 02 2004 David Summers <david@summersoft.fay.ar.us> 1.03-27
- Added SPF capability with libspf Version 0.24 library.

* Thu Mar 25 2004 David Summers <david@summersoft.fay.ar.us> 1.03-26
- SMTP AUTH patch.  This is different from the previous try in that it
  advertises the AUTH command a couple of different ways so different clients
  will work correctly.
- Now requires checkpassword package to do SMTP authentication.
- Now starts smtps (SMTP SSL) service on standard port 465.
- *** WARNING: Divided into two services (qmail and qmail-smtpd). qmail-smtpd
  starts both SMTP and SMTPS service.
- Bumped SMTP and SMTPS memory requirements to 400000.
- Added STARTTLS patch.

* Fri Jan 23 2004 David Summers <david@summersoft.fay.ar.us> 1.03-25
- Changes for Solaris 2.9. qmail-client package untested on Solaris.
- Bumped smtpd memory limits to 300000 because Solaris requires more.
- Moved newaliases to /usr/sbin directory.
- Fixed bug with creating /etc/skel/Maildir if it already exists.

* Wed Sep 03 2003 David Summers <david@summersoft.fay.ar.us> 1.03-24
- Fixed compile error for Redhat9 "errno" variable.

* Fri Feb 21 2003 David Summers <david@summersoft.fay.ar.us> 1.03-23
- Changed /var/qmail/supervise/qmail-smtpd/log/run to take out the
  /var/log/qmail/smtpd and put it in the SMTPD_LOG_OPTIONS variable in the
  /etc/qmail/smtpd.config file.  This allows the administrator to utilize all
  the multilog options.
- Fixed /var/qmail/queue/lock/{sendmutex,tcpto} to be included in the packaging
  to accomodate RedHat 8.0 RPM's more strict packaging checks.
- Fixed capitalization error in /etc/profile.d/qmail.sh.
- Added /etc/skel/Maildir for new user creation.

* Sun Aug 11 2002 David Summers <david@summersoft.fay.ar.us> 1.03-22
- Add IPV6 capability.

* Mon Jul 29 2002 David Summers <david@summersoft.fay.ar.us> 1.03-21
  Took out smtp-auth patch.  Too many problems with clients.

* Tue Dec 25 2001 David Summers <david@summersoft.fay.ar.us> 1.03-20
- Added qmail-queue patch to OPTIONALLY change the qmail-queue program.
  Added qmail-auth  patch to OPTIONALLY authenticate SMTP senders.
  Added /usr/bin/qfilter-tmda.
  (These are handy for programs like TMDA).

* Sat Dec 23 2001 David Summers <david@summersoft.fay.ar.us> 1.03-19
- *** Major changes - Untested with Solaris (will do it later).
  Took out rblsmtp and replaced with ucspi-tcp (tcpserver).
  Added daemontools.
  Now does *NOT* use TCP_WRAPPERS (/etc/hosts.{allow,deny}) but /etc/tcp.smtp.
  Now does *NOT* use INETD or XINETD but ucspi-tcp and daemontools.
  /etc/qmail/dot-qmail -> /etc/qmail/default-delivery.
  Now separates out qmail-send service and qmail-smtpd service as startup items.
  Now default mail delivery is to Maildir instead of Mailbox.

* Sun Apr 01 2001 David Summers <david@summersoft.fay.ar.us> 1.03-18
- Fixed minor problems caused by new versions of RPM.

* Sat Sep 30 2000 David Summers <david@summersoft.fay.ar.us> 1.03-17
- Updated to work with Redhat 7.0 (and previous releases).
  Should work with Solaris but not yet tested.
  Now requires tcp_wrappers.
  Added "restart" and "flush" to /etc/init.d/qmail script.
  Added SSMTP (SSL SMTP). (Won't work without XINETD and STUNNEL).

* Thu Apr 06 2000 David Summers <david@summersoft.fay.ar.us> 1.03-16
- Finally added /usr/lib/sendmail to be more sendmail compatible on Linux.

* Sun Mar 19 2000 David Summers <david@summersoft.fay.ar.us> 1.03-15
- Fixed verify for different files.

* Thu Mar 16 2000 David Summers <david@summersoft.fay.ar.us> 1.03-14
- Added "." to /var/qmail/users/assign so qmail-newu won't give error.
  (Thanks to kcozens@pc.ve3syb.on.ca)

* Tue Feb 08 2000 David Summers <dws@engr.uark.edu> 1.03-13
- Changed "%ifos Solaris" to "%ifnos Linux".

* Mon Feb 07 2000 David Summers <david@summersoft.fay.ar.us> 1.03-12
- Verified operation on Solaris. /etc/aliases already exists so don't treat it
     as a config file.

* Sun Feb 06 2000 David Summers <david@summersoft.fay.ar.us> 1.03-11
- Added mfcheck optional spam patch.
  Took out extra Solaris init scripts.

* Sun Nov 28 1999 David Summers <david@summersoft.fay.ar.us> 1.03-10
- Finally got around to adding newaliases link.
  Only copy aliases file for Linux because Solaris already has it.
  Fixed silly setting of files to qmail group (in docs and others).

* Thu Jul 08 1999 David Summers <dws@engr.uark.edu> 1.03-9
- Ouch! RPM 3.0 changed from OS=SunOS to OS=solaris.

* Sat Jun 26 1999 David Summers <david@summersoft.fay.ar.us> 1.03-8
- Fixed to work with LinuxPPC Release 5, don't need "ppc patch" anymore, but
  brand had to change.
- Changed "install" to not require building by root.
- Changed (/etc/rc.d/init.d/qmail) to use Linux "chkconfig".
- Changed file unpacking to be silent.

* Tue Sep 01 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-7
- Patch to work with MkLinux DR3 and LinuxPPC Release 4.

* Wed Aug 26 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-6
- Changed rblsmtpd to optionally print logging information so by default it
  won't print out to the SMTP socket when used with INETD.

* Mon Aug 24 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-5
- Changed to rblsmtpd-0.70 package.

* Fri Aug 14 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-4
- Added rblsmtpd-0.50 package.
- Fixed dot-forward and fast forward packages not to complain while compiling on
  Solaris.
- Added documentation that qmail install didn't get.

* Wed Aug 05 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-3
- Added dot-forward-0.71 package.
- Added fastforward-0.51 package.

* Fri Jun 19 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-2
- Now creates backups of /etc/inetd.conf and /etc/services files.
- Fixed problem with wiping out /etc/services caused by misplaced parenthesis.

* Mon Jun 15 1998 David W. Summers <david@summersoft.fay.ar.us> 1.03-1
- conf-patrn flip-flopped from 1.02 to 1.03, hence qmail-1.03.solaris.patch.
- Started with qmail-1.03 sources and qmail-1.02-9.spec file.

#
# MACROS
#
# Find users and groups and brand files with uids and gids.
# Set permissions, owners and groups
%define brand cd /var/qmail/bin; ./brand install instcheck qmail-lspawn qmail-queue qmail-rspawn qmail-showctl qmail-start; /var/qmail/bin/install -d

# Error message if users or groups already exist
%define user_group_error (echo "Error $? : Required user or group already exists, please check /etc/passwd, /etc/group, and /etc/shadow files."; exit 1)

# Set FUZZ to 2 by default which is how RPM has previously worked.
%define _default_patch_fuzz 2

%prep
# QMAIL 1.03 Package
%setup -q
# DOT FORWARD Package
%setup -q -D -T -a 1
# FAST FORWARD Package
%setup -q -D -T -a 2
# SMTP AUTH Package
%setup -q -D -T -a 20
# SPF Package
%setup -q -D -T -a 24

# SMTP AUTH patch
patch -p0 < qmail-smtpd-auth-0.31/auth.patch

mv qmail-smtpd-auth-0.31/*.h .
mv qmail-smtpd-auth-0.31/*.c .

# STARTTLS patch
%patch11 -p1 -b .starttls

# Fix install
%patch0 -p1 -b .install

# RedHat patch
%patch2 -p1 -b .redhat

# IDs patch
%patch4 -p1 -b .ids

# MFCHECK patch.
%patch6 -p1 -b .mfcheck

# QMAIL-QUEUE patch.
%patch7 -p1 -b .queue

# IPV6 patch.
%patch8 -p1 -b .ipv6

# Redhat 9 patch for "errno" problem.
%patch9 -p1 -b .errno

%ifnos linux
# Patch for solaris
%patch3 -p1 -b .solaris
%endif

# Disable AUTH CRAM-MD5
%patch10 -p0 -b .auth

# SPF
%patch12 -p0 -b .spf1
%patch13 -p0 -b .spf2
%patch14 -p0 -b .spf3

ln -s libspf-1.0.0-p5/src/libspf/spf.h

# QMTP patch
%patch15 -p0 -b .qmtp
%patch16 -p1 -b .qmtp-netstring

# maildir.header.patch
%patch17 -p1 -b .maildir-header

# any-to-cname.patch
%patch18 -p1 -b .any-to-cname

# Big DNS response patch.
%patch19 -p1 -b big.dns.response.

# SPF
cd libspf-1.0.0-p5
%ifnos linux
ln deprecated/error.h .
%endif
rm -rf configure
rm -rf libtool
rm -rf auto*
rm -rf build_tools/*
aclocal
libtoolize
automake --add-missing
autoconf
os=`$RPM_SOURCE_DIR/find-osrel`
if [ "$os"x = "rhel6"x ]; then
%patch20 -p0 -b libspf.rhel6
fi
./configure --enable-static -enable-pthreads
if [ "$os"x = "rhel6"x ]; then
%patch21 -p0 -b libspf.rhel6.post.configure
fi

%build
cp $RPM_SOURCE_DIR/brand.c .
cp $RPM_SOURCE_DIR/auto_uids.c .
cp $RPM_SOURCE_DIR/find-osrel .

# SPF
cd libspf-1.0.0-p5
make
# Test SPF
#cd src/spfqtool
#perl test.pl < test.txt
#cd ../..
cd ..

# QMAIL
make
mv qmail-queue qmail-queue.orig
patch -p1 < $RPM_SOURCE_DIR/qmail-1.03.msglog.patch
make
mv qmail-queue qmail-queue.msglog
mv qmail-queue.orig qmail-queue
./compile -g brand.c
./load brand
make man

# DOT FORWARD
(cd dot-forward-0.71
make)

# FAST FORWARD
(cd fastforward-0.51
make)

%install
%ifos linux
extra=rc.d
%endif
/bin/rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/qmail/alias
mkdir -p $RPM_BUILD_ROOT/etc/qmail/control
mkdir -p $RPM_BUILD_ROOT/etc/qmail/users
mkdir -p $RPM_BUILD_ROOT/usr/bin/qmail
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03
mkdir -p $RPM_BUILD_ROOT/usr/lib/qmail/boot
mkdir -p $RPM_BUILD_ROOT/usr/man
mkdir -p $RPM_BUILD_ROOT/var/log/qmail/send
mkdir -p $RPM_BUILD_ROOT/var/log/qmail/smtpd
mkdir -p $RPM_BUILD_ROOT/var/log/qmail/qmtpd
mkdir -p $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send/log
chmod +t $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send
mkdir -p $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd/log
chmod +t $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd
mkdir -p $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd/log
chmod +t $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd
chmod 755 $RPM_BUILD_ROOT/var/qmail
ln -sf ../../etc/qmail/alias $RPM_BUILD_ROOT/var/qmail
ln -sf ../../usr/lib/qmail/boot $RPM_BUILD_ROOT/var/qmail/boot
ln -sf ../../etc/qmail/control $RPM_BUILD_ROOT/var/qmail
ln -sf ../../etc/qmail/users $RPM_BUILD_ROOT/var/qmail
ln -sf ../../usr/share/doc/qmail-1.03 $RPM_BUILD_ROOT/var/qmail/doc
ln -sf ../../usr/bin/qmail $RPM_BUILD_ROOT/var/qmail/bin
ln -sf ../../usr/man $RPM_BUILD_ROOT/var/qmail/man
# Save old Install and Check
mv install install.old
mv instcheck instcheck.old
# Fix Install and Check
sed "s;/var/qmail;$RPM_BUILD_ROOT/var/qmail;" conf-qmail > conf-qmail.tmp
mv conf-qmail.tmp conf-qmail
# Compile Install and Check
make install instcheck
# Compress Man Pages
gzip *.[0-9]
# INSTALL IT
mv qmail-remote qmail-remote.orig
./install -c
# Check it
#./instcheck
# Move old versions of Install and Check back
mv install.old install
mv instcheck.old instcheck
cp qmail-queue.msglog $RPM_BUILD_ROOT/var/qmail/bin

# Copy documentation that qmail install didn't get.
cp BLURB* README SECURITY THANKS THOUGHTS TODO VERSION $RPM_BUILD_ROOT/var/qmail/doc

# Sendmail compatable fix for user to see mail queue
ln -s qmail/qmail-qread $RPM_BUILD_ROOT/usr/bin/mailq

# Set up post installation programs
cp ./brand ./install ./instcheck ./config ./config-fast ./dnsfq ./dnsip ./dnsptr ./hostname ./ipmeprint $RPM_BUILD_ROOT/var/qmail/bin

# Set up boot procedures
%ifos linux
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
%else
(mkdir -p $RPM_BUILD_ROOT/etc/$extra; cd $RPM_BUILD_ROOT/etc/$extra;
mkdir -p init.d rc3.d
)
%endif

%ifos linux
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
cp $RPM_SOURCE_DIR/qmail-linux.sh $RPM_BUILD_ROOT/etc/profile.d/qmail.sh
cp $RPM_SOURCE_DIR/qmail-linux.csh $RPM_BUILD_ROOT/etc/profile.d/qmail.csh
chmod a+x $RPM_BUILD_ROOT/etc/profile.d/qmail*
%endif
cp %{SOURCE5} $RPM_BUILD_ROOT/etc/$extra/init.d/qmail
chmod a+x $RPM_BUILD_ROOT/etc/$extra/init.d/qmail
cp %{SOURCE22} $RPM_BUILD_ROOT/etc/$extra/init.d/qmail-smtpd
chmod a+x $RPM_BUILD_ROOT/etc/$extra/init.d/qmail-smtpd
cp %{SOURCE26} $RPM_BUILD_ROOT/etc/$extra/init.d/qmail-qmtpd
chmod a+x $RPM_BUILD_ROOT/etc/$extra/init.d/qmail-qmtpd
%ifnos linux
ln -s ../init.d/qmail $RPM_BUILD_ROOT/etc/$extra/rc3.d/K30qmail
ln -s ../init.d/qmail $RPM_BUILD_ROOT/etc/$extra/rc3.d/S80qmail
%endif

mkdir -p $RPM_BUILD_ROOT/usr/sbin
%ifos linux
mkdir -p $RPM_BUILD_ROOT/usr/lib
(cd $RPM_BUILD_ROOT/usr/sbin;
ln -sf ../../var/qmail/bin/sendmail;
cd $RPM_BUILD_ROOT/usr/lib;
ln -sf ../../var/qmail/bin/sendmail;
cd $RPM_BUILD_ROOT/usr/sbin;
ln -s ../../var/qmail/bin/newaliases
)
%else
mkdir -p $RPM_BUILD_ROOT/usr/lib
(cd $RPM_BUILD_ROOT/usr/lib;
ln -sf ../../var/qmail/bin/sendmail;
cd $RPM_BUILD_ROOT/usr/sbin;
ln -sf ../../var/qmail/bin/newaliases
)
%endif

# Set up mailing aliases (Solaris already has these so we don't copy).
cp /dev/null alias-manifest
%ifos linux
os=`./find-osrel`
if [ "$os"x != "rhel4"x -a "$os"x != "rhel5"x -a "$os"x != "rhel6"x ]; then
  cp $RPM_SOURCE_DIR/qmail-aliases $RPM_BUILD_ROOT/etc/aliases
  echo "%defattr(-,root,root)" >> alias-manifest
  echo "%config /etc/aliases" >> alias-manifest
fi
%endif
(cd $RPM_BUILD_ROOT/etc/qmail/alias;
touch .qmail-root;
cp $RPM_SOURCE_DIR/qmail-msglog  .qmail-msglog
cp $RPM_SOURCE_DIR/qmail-default .qmail-default
chmod 644 .qmail*
)

# Set up control files.
(cd $RPM_BUILD_ROOT/etc/qmail/control;
touch defaultdomain locals me qmqpservers rcpthosts;
chmod 644 *;
)

# Set up blank qmail/users
(cd $RPM_BUILD_ROOT/etc/qmail/users;
touch assign include exclude mailnames subusers append
echo "." > assign
)

# Set up default delivery
cp $RPM_SOURCE_DIR/qmail-default-delivery $RPM_BUILD_ROOT/etc/qmail/default-delivery

# DOT FORWARD command and doc
cp dot-forward-0.71/dot-forward $RPM_BUILD_ROOT/var/qmail/bin
cp dot-forward-0.71/dot-forward.1 $RPM_BUILD_ROOT/var/qmail/man/man1

# FAST FORWARD commands and docs
cp fastforward-0.51/fastforward $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/newaliases $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/newinclude $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/printforward $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/printmaillist $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/setforward $RPM_BUILD_ROOT/var/qmail/bin
cp fastforward-0.51/setmaillist $RPM_BUILD_ROOT/var/qmail/bin

cp fastforward-0.51/fastforward.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/newaliases.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/newinclude.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/printforward.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/printmaillist.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/setforward.1 $RPM_BUILD_ROOT/var/qmail/man/man1
cp fastforward-0.51/setmaillist.1 $RPM_BUILD_ROOT/var/qmail/man/man1

cp fastforward-0.51/ALIASES $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03

# Add rc boot script
cp %{SOURCE6} $RPM_BUILD_ROOT/var/qmail/rc
chmod a+rx $RPM_BUILD_ROOT/var/qmail/rc

# Set up supervise scripts
cp %{SOURCE3} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send/run
chmod a+x     $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send/run

cp %{SOURCE4} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send/log/run
chmod a+x     $RPM_BUILD_ROOT/var/qmail/supervise/qmail-send/log/run

cp %{SOURCE15} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd/run
chmod a+x      $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd/run

cp %{SOURCE16} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd/log/run
chmod a+x      $RPM_BUILD_ROOT/var/qmail/supervise/qmail-smtpd/log/run

cp %{SOURCE27} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd/run
chmod a+x      $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd/run

cp %{SOURCE28} $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd/log/run
chmod a+x      $RPM_BUILD_ROOT/var/qmail/supervise/qmail-qmtpd/log/run

# Set default smtpd options.
echo 'MAX_SMTPD_MEMORY="6000000"'         > $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo 'SMTPD_PORT=25'                      >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo 'SMTPD_IDENT_OPTION="-R"'            >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo 'SMTPD_LISTEN_OPTIONS="-l 0"'        >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo 'MAX_SMTPD_CONCURRENCY="20"'         >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo '#SMTPD_RBL_COMMAND="/bin/rblsmtpd"' >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
echo 'SMTPD_LOG_OPTIONS="t /var/log/qmail/smtpd"' >> $RPM_BUILD_ROOT/etc/qmail/smtpd.config
chmod a+x                             $RPM_BUILD_ROOT/etc/qmail/smtpd.config

# Set default qmtpd options.
echo 'MAX_QMTPD_MEMORY="6000000"'         > $RPM_BUILD_ROOT/etc/qmail/qmtpd.config
echo 'QMTPD_IDENT_OPTION="-R"'            >> $RPM_BUILD_ROOT/etc/qmail/qmtpd.config
echo 'QMTPD_LISTEN_OPTIONS="-l 0"'        >> $RPM_BUILD_ROOT/etc/qmail/qmtpd.config
echo 'MAX_QMTPD_CONCURRENCY="20"'         >> $RPM_BUILD_ROOT/etc/qmail/qmtpd.config
echo 'QMTPD_LOG_OPTIONS="t /var/log/qmail/qmtpd"' >> $RPM_BUILD_ROOT/etc/qmail/qmtpd.config
chmod a+x                             $RPM_BUILD_ROOT/etc/qmail/qmtpd.config

# Setup tcp.smtp file.
echo ":allow" > $RPM_BUILD_ROOT/etc/tcp.smtp

# Setup tcp.qmtp file.
echo ":allow" > $RPM_BUILD_ROOT/etc/tcp.qmtp

# Copy mbox2maildir
cp %{SOURCE17} $RPM_BUILD_ROOT/var/qmail/bin

# Set up qfilter-tmda
cp %{SOURCE19} $RPM_BUILD_ROOT/usr/bin/qfilter-tmda

# Copy Makefile-cert to /etc/qmail directory.
cp Makefile-cert.mk $RPM_BUILD_ROOT/etc/qmail/Makefile

# Copy SPF documentation and programs.
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03/SPF
cp libspf-1.0.0-p5/docs/qmail/*.html $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03/SPF
cp libspf-1.0.0-p5/bin/spfqtool_static $RPM_BUILD_ROOT/usr/bin/qmail/spfqtool

# Copy AUTH documentation
cp qmail-smtpd-auth-0.31/README.auth $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03/README.auth

# Copy new qmail.remote (DKIM) shell (qmail-remote has already been moved to
# qmail-remote.orig
cp %{SOURCE29} $RPM_BUILD_ROOT/usr/bin/qmail/qmail-remote
chmod a+rx $RPM_BUILD_ROOT/usr/bin/qmail/qmail-remote

# Copy DKIM/Domainkeys signing configuration file to correct directory.
mkdir -p $RPM_BUILD_ROOT/etc/qmail/control/dkim
cp %{SOURCE30} $RPM_BUILD_ROOT/etc/qmail/control/dkim

# END INSTALL

%pre
# qmail Pre-install script.
# If package is being installed for the first time
if [ $1 = 1 ]; then

# Set up to create user account on Linux.
SYSUSER="-r"

%ifnos linux

#This is not Linux, so disable the SYSUSER option.
SYSUSER=""

# Stop sendmail and try to clear mail queue.
/etc/init.d/sendmail stop

# Check for un-commented /dev/null in aliases and abort installation
# until administrator changes those aliases.
g=`grep /dev/null /etc/mail/aliases | grep -v '^#'`
if [ "$g"x != "x" ]; then
   echo "Please remove /dev/null references in /etc/mail/aliases"
   echo "and re-install qmail."
   exit 1
fi

if [ -f /usr/lib/sendmail ]; then
   /usr/lib/sendmail -q -v > /tmp/qmail.nstall.$$.log 2>&1
   #echo "Saving /usr/lib/sendmail"
   mv /usr/lib/sendmail /usr/lib/sendmail.pre.qmail
fi

if [ -f /etc/mail/sendmail.cf ]; then
   #echo "Saving /etc/mail/sendmail.cf"
   mv /etc/mail/sendmail.cf /etc/mail/sendmail.cf.pre.qmail
fi

if [ -f /usr/sbin/newaliases ]; then
   #echo "Saving /usr/sbin/newaliases"
   mv /usr/sbin/newaliases /usr/sbin/newaliases.pre.qmail
fi
%endif

groupadd $SYSUSER nofiles || %{user_group_error};
useradd $SYSUSER -g nofiles -d /var/qmail qmaild || %{user_group_error};
useradd $SYSUSER -g nofiles -d /var/qmail qmaill || %{user_group_error};
useradd $SYSUSER -g nofiles -d /var/qmail qmailp || %{user_group_error};
useradd $SYSUSER -g nofiles -d /var/qmail/alias alias || %{user_group_error};
groupadd $SYSUSER qmail || %{user_group_error};
useradd $SYSUSER -g qmail -d /var/qmail qmailq || %{user_group_error};
useradd $SYSUSER -g qmail -d /var/qmail qmailr || %{user_group_error};
useradd $SYSUSER -g qmail -d /var/qmail qmails || %{user_group_error};

# Remove files put there by useradd.
rm -rf /var/qmail/.[a-zA-Z]*
rm -rf /var/qmail/*

if [ -d /var/qmail ]; then
   chmod a+r /var/qmail
   chown alias /var/qmail
fi

# Because it is a symbolic link.
rm -rf /var/qmail/alias

fi # End Package installed for first time.

%post
# qmail Post-install script
%ifos linux
# Set up start up routines
/sbin/chkconfig --add qmail
/sbin/chkconfig --add qmail-smtpd
/sbin/chkconfig --add qmail-qmtpd
%endif

# Brand with correct UID, GID.
%{brand}
#/var/qmail/bin/instcheck

# Set file permissions.
chown alias:qmail /etc/qmail/alias

# Set for user access.
chmod u+s /var/qmail/bin/qmail-qread

# Run configuration script.
./config >> /tmp/qmail.install.$$.log 2>&1

# Set up aliases
/var/qmail/bin/newaliases

# Compile TCP RULES file (tcp.smtp and tcp.qmtp)
/etc/init.d/qmail-smtpd rules
/etc/init.d/qmail-qmtpd rules

# Set up skeleton Maildir for new users.
(cd /etc/skel;
if [ ! -d Maildir ]; then
   /usr/bin/qmail/maildirmake Maildir
fi
)

# Set up DKIM signing if needed
if [ ! -f /var/qmail/control/dkim/global.key ]; then
  cd /var/qmail/control/dkim
  /usr/bin/dknewkey global.key 1024 > global.dns
fi

%preun
# qmail Pre-uninstall script.
%ifos linux
extra=rc.d
%endif

if [ -f /etc/$extra/init.d/qmail ]; then
   /etc/$extra/init.d/qmail stop
   /etc/$extra/init.d/qmail-smtpd stop
   /etc/$extra/init.d/qmail-qmtpd stop
fi

# If package is being erased for the last time.
if [ $1 = 0 ]; then

   # Delete qmail users
   userdel alias    || true;
   userdel qmaild   || true;
   userdel qmailq   || true;
   userdel qmailr   || true;
   userdel qmails   || true;
   userdel qmaill   || true;
   userdel qmailp   || true;

   # Delete qmail groups
   groupdel qmail   || true;
   groupdel nofiles || true;

%ifos linux
   /sbin/chkconfig --del qmail
%endif

   # Delete skeleton Maildir directory.
   /bin/rm -rf /etc/skel/Maildir
fi

%postun
# qmail Post-uninstall script.
%ifnos linux
if [ $1 = 0 ]; then
   if [ -f /usr/lib/sendmail.pre.qmail ]; then
      #echo "Restore /usr/lib/sendmail"
      mv /usr/lib/sendmail.pre.qmail /usr/lib/sendmail
   fi

   if [ -f /etc/mail/sendmail.cf.pre.qmail ]; then
      #echo "Restore /etc/mail/sendmail.cf"
      mv /etc/mail/sendmail.cf.pre.qmail /etc/mail/sendmail.cf
   fi

   if [ -f /usr/sbin/newaliases.pre.qmail ]; then
      #echo "Restore /usr/sbin/newaliases"
      mv /usr/sbin/newaliases.pre.qmail /usr/sbin/newaliases
   fi
# End if package is being un-installed for last time.
fi

/bin/rm -rf /var/log/qmail

%endif

%pre msglog
# qmail-msglog Pre-install script.
%ifos linux
extra=rc.d
%endif
/etc/$extra/init.d/qmail-send stop

%post msglog
# qmail-msglog Post-install script.
cd /var/qmail/bin
mv qmail-queue qmail-queue.pre.msglog
cp qmail-queue.msglog qmail-queue
%{brand}
#/var/qmail/bin/instcheck

%preun msglog
# qmail-msglog Pre-uninstall script.
if [ -f /usr/bin/qmail/qmail-queue.pre.msglog ]; then
   cd /usr/bin/qmail
   mv qmail-queue.pre.msglog qmail-queue
fi

%pre client
# qmail-client Pre-install script.
%ifnos linux
# If package is being installed for the first time
if [ $1 = 1 ]; then
   # Stop sendmail and try to clear mail queue.
   /etc/init.d/sendmail stop

   if [ -f /usr/lib/sendmail ]; then
      /usr/lib/sendmail -q -v > /tmp/qmail.install.$$.log 2>&1
      #echo "Saving /usr/lib/sendmail"
      mv /usr/lib/sendmail /usr/lib/sendmail.pre.qmail
   fi

   if [ -f /etc/mail/sendmail.cf ]; then
      #echo "Saving /etc/mail/sendmail.cf"
      mv /etc/mail/sendmail.cf /etc/mail/sendmail.cf.pre.qmail
   fi
# End Package installed for first time.
fi
%endif

%post client
# qmail-client Post-install script.
# Run configuration script.
cd /var/qmail/bin
# Set up for QMAIL CLIENT
rm qmail-queue
ln -sf qmail-qmqpc qmail-queue
# Configure client control files.
./config >> /tmp/qmail.install.$$.log 2>&1
# Remove unneeded control files generated by config
rm /etc/qmail/control/locals
rm /etc/qmail/control/rcpthosts

%postun client
# qmail-client Post-uninstall script.
%ifnos linux
# If package is being un-installed for last time.
if [ $1 = 0 ]; then
if [ -f /usr/lib/sendmail.pre.qmail ]; then
   #echo "Restore /usr/lib/sendmail"
   mv /usr/lib/sendmail.pre.qmail /usr/lib/sendmail
fi

if [ -f /etc/mail/sendmail.cf.pre.qmail ]; then
   #echo "Restore /etc/mail/sendmail.cf"
   mv /etc/mail/sendmail.cf.pre.qmail /etc/mail/sendmail.cf
fi
# End if package is being un-installed for last time.
fi
%endif

%clean
# Clean up after compiling and installing.
%if %{undefined nocleanstage}
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
%endif

%files -f alias-manifest
# qmail package file list.
%defattr(-,root,root)
%config /etc/tcp.smtp
%config /etc/tcp.qmtp
%config /etc/qmail/alias/.qmail-root
%config /etc/qmail/alias/.qmail-default
%config /etc/qmail/default-delivery
%config /etc/qmail/smtpd.config
%config /etc/qmail/qmtpd.config
%config /etc/qmail/control/defaultdomain
%config /etc/qmail/control/locals
%config /etc/qmail/control/me
%config /etc/qmail/control/rcpthosts
%config /etc/qmail/control/dkim/signconf.xml
%attr(0550,qmailr,qmail) /etc/qmail/control/dkim
%verify(not group) %config /etc/qmail/users
%ifos linux
%config /etc/profile.d/*
%endif
/etc/qmail/Makefile
%docdir /usr/share/doc/qmail-1.03
%docdir /usr/man
%ifos linux
/etc/rc.d/init.d/qmail
/etc/rc.d/init.d/qmail-smtpd
/etc/rc.d/init.d/qmail-qmtpd
%else
/etc/init.d/qmail
/etc/init.d/qmail-smtpd
/etc/init.d/qmail-qmtpd
/etc/rc3.d/K30qmail
/etc/rc3.d/S80qmail
%endif
/usr/bin/mailq
/usr/bin/qfilter-tmda
/usr/bin/qmail/brand
/usr/bin/qmail/bouncesaying
/usr/bin/qmail/condredirect
/usr/bin/qmail/config
/usr/bin/qmail/config-fast
/usr/bin/qmail/datemail
/usr/bin/qmail/dnsfq
/usr/bin/qmail/dnsip
/usr/bin/qmail/dnsptr
/usr/bin/qmail/dot-forward
/usr/bin/qmail/elq
/usr/bin/qmail/except
/usr/bin/qmail/forward
/usr/bin/qmail/hostname
%verify(not md5 mtime) /usr/bin/qmail/install
%verify(not md5 mtime) /usr/bin/qmail/instcheck
/usr/bin/qmail/ipmeprint
/usr/bin/qmail/maildir2mbox
/usr/bin/qmail/maildirmake
/usr/bin/qmail/maildirwatch
/usr/bin/qmail/mailsubj
/usr/bin/qmail/pinq
/usr/bin/qmail/predate
/usr/bin/qmail/preline
/usr/bin/qmail/qail
/usr/bin/qmail/qbiff
/usr/bin/qmail/qmail-clean
/usr/bin/qmail/qmail-getpw
/usr/bin/qmail/qmail-inject
/usr/bin/qmail/qmail-local
%verify(not md5 mtime) /usr/bin/qmail/qmail-lspawn
/usr/bin/qmail/mbox2maildir
/usr/bin/qmail/qmail-newmrh
/usr/bin/qmail/qmail-newu
/usr/bin/qmail/qmail-pop3d
/usr/bin/qmail/qmail-popup
/usr/bin/qmail/qmail-pw2u
/usr/bin/qmail/qmail-qmqpc
/usr/bin/qmail/qmail-qmqpd
/usr/bin/qmail/qmail-qmtpd
%verify(not mode) /usr/bin/qmail/qmail-qread
/usr/bin/qmail/qmail-qstat
%verify(not md5 user mtime) /usr/bin/qmail/qmail-queue
/usr/bin/qmail/qmail-remote
%verify(not md5 mtime) /usr/bin/qmail/qmail-rspawn
/usr/bin/qmail/qmail-send
%verify(not md5 mtime) /usr/bin/qmail/qmail-showctl
/usr/bin/qmail/qmail-smtpd
%verify(not md5 mtime) /usr/bin/qmail/qmail-start
/usr/bin/qmail/qmail-tcpok
/usr/bin/qmail/qmail-tcpto
/usr/bin/qmail/qreceipt
/usr/bin/qmail/qsmhook
/usr/bin/qmail/sendmail
/usr/bin/qmail/spfqtool
/usr/bin/qmail/splogger
/usr/bin/qmail/tcp-env
/usr/bin/qmail/fastforward
/usr/bin/qmail/newaliases
/usr/bin/qmail/newinclude
/usr/bin/qmail/printforward
/usr/bin/qmail/printmaillist
/usr/bin/qmail/setforward
/usr/bin/qmail/setmaillist
/usr/bin/qmail/update_tmprsadh
%dir /usr/bin/qmail
/usr/sbin/newaliases
%ifos linux
/usr/sbin/sendmail
%endif
/usr/lib/sendmail
/usr/share/doc/qmail-1.03
/usr/man/man*/*
/usr/lib/qmail/*
%attr(-,qmaill,root) /var/log/qmail
/var/qmail/alias
/var/qmail/bin
/var/qmail/boot
/var/qmail/control
/var/qmail/doc
/var/qmail/man
/var/qmail/supervise
# queue left out on purpose as it is ALWAYS going to be different and
# non-verifiable. However, pick up queue/lock/sendmutex and queue/locl/tcpto.
%attr(0600,qmails,qmail) %verify(not md5 mtime) /var/qmail/queue/lock/sendmutex
%attr(0644,qmailr,qmail) %verify(not md5 mtime) /var/qmail/queue/lock/tcpto
/var/qmail/rc
/var/qmail/users
/usr/bin/qmail/qmail-remote.orig

# qmail-msglog package file list.
%files msglog
%defattr(-,root,root)
%config /etc/qmail/alias/.qmail-msglog
/usr/bin/qmail/qmail-queue.msglog

# qmail-client package file list.
%files client
%defattr(-,root,root)
%config /etc/qmail/control
%ifos linux
%config /etc/profile.d/*
%endif
%docdir /usr/share/doc/qmail-1.03
%docdir /usr/man
/usr/bin/qmail/config
/usr/bin/qmail/config-fast
/usr/bin/qmail/datemail
/usr/bin/qmail/dnsfq
/usr/bin/qmail/dnsip
/usr/bin/qmail/dnsptr
/usr/bin/qmail/elq
/usr/bin/qmail/hostname
/usr/bin/qmail/ipmeprint
/usr/bin/qmail/pinq
/usr/bin/qmail/predate
/usr/bin/qmail/qmail-inject
/usr/bin/qmail/qmail-qmqpc
/usr/bin/qmail/qmail-queue
/usr/bin/qmail/qmail-showctl
/usr/bin/qmail/sendmail
%dir /usr/bin/qmail
%ifos linux
/usr/sbin/sendmail
%endif
/usr/lib/sendmail
/usr/share/doc/qmail-1.03
/usr/man/man*/*
/var/log/qmail
/var/qmail/bin
/var/qmail/control
/var/qmail/doc
/var/qmail/man
%dir /var/qmail
